=== source/CMakeLists.txt ===
add_subdirectory(core)
add_subdirectory(crystal)
add_subdirectory(em)
add_subdirectory(math)
add_subdirectory(rigidbody)
add_subdirectory(gui)
