=== debian/changelog ===
ausaxs (1.1.8-1) unstable; urgency=low

  * Initial release of ausaxs library for pyAUSAXS Python module.

 -- Stuart Prescott <stuart@debian.org>  Mon, 19 Jan 2026 17:17:39 +1100
