=== debian/control ===
Source: ausaxs
Section: libs
Maintainer: Stuart Prescott <stuart@debian.org>
Build-Depends:
 debhelper-compat (= 13),
 cmake,
 doxygen,
 libbackward-cpp-dev,
 libcairo2-dev,
 libcatch2-dev,
 libcli11-dev,
 libcurl4-openssl-dev,
 libgcem-dev,
 libgtk-3-dev,
 libbs-thread-pool-dev,
 libwebp-dev,
Standards-Version: 4.7.3
Homepage: https://github.com/AUSAXS/AUSAXS/
Vcs-Git: https://salsa.debian.org/science-team/ausaxs.git
Vcs-Browser: https://salsa.debian.org/science-team/ausaxs

Package: libausaxs
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: AUSAXS scattering calculator library
 The AUSAXS library is a calculation engine for evaluating the scattering
 intensity of biological samples and crystals. The calculations are
 based on the Debye equation and the library can be used to fit
 high-resolution models to SAXS curves, with options for the handling of
 both the excluded volume and hydration shell.
