=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@ --buildsystem cmake

override_dh_auto_configure:
	dh_auto_configure -- \
          -DGUI=OFF \
          -DDLIB=OFF \
          -DUSE_SYSTEM_GCEM=ON \
          -DUSE_SYSTEM_BACKWARD=ON \
          -DUSE_SYSTEM_CLI11=ON \
          -DUSE_SYSTEM_THREADPOOL=ON \
          -DUSE_SYSTEM_CATCH=ON

override_dh_auto_build:
	dh_auto_build -- \
          ausaxs saxs_fitter em_fitter rigidbody_optimizer

override_dh_auto_install:
	# We might install these tools in a separate package, one day..
	# mkdir -p $(CURDIR)/debian/ausaxs/usr/bin
	# cp -v obj*/bin/saxs_fitter obj*/bin/em_fitter obj*/bin/rigidbody_optimizer $(CURDIR)/debian/ausaxs/usr/bin/

	mkdir -p $(CURDIR)/debian/libausaxs/usr/lib/ausaxs/
	cp -v obj*/lib/libausaxs.so $(CURDIR)/debian/libausaxs/usr/lib/ausaxs

	# Not yet a library that other things will compile against, one day...
	# mkdir -p $(CURDIR)/debian/libausaxs-dev/usr/include/$(DEB_HOST_MULTIARCH)/
	# cp -rv include/core/api $(CURDIR)/debian/libausaxs-dev/usr/include/$(DEB_HOST_MULTIARCH)/
